require 'knifer_sutherland/host'

class Chef
  class Knife
    class HostsFile < Knife
      deps do
        require 'chef/knife/bootstrap'
        Chef::Knife::Bootstrap.load_deps
      end

      banner "knife hosts_file (options)"

      def run
        nodes = query_nodes(@name_args[0] || "*:*")
        KniferSutherland::Host.new.write_nodes_to_host_file(nodes)
      end

      def query_nodes(search)
        nodes = Hash.new
        Chef::Search::Query.new.search(:node, search) do |node|
          nodes[ip_address(node)] = node.name
        end
        nodes
      end

      def ip_address(node)
        node.has_key?("ec2") ? node['ec2']['public_ipv4'] : node['ipaddress']
      end
    end
  end
end
